package com.steerinfo.meterwork.meterworksceneregister.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.meterwork.meterworksceneregister.model.MeterWorkSceneRegister;
import com.steerinfo.meterwork.meterworksceneregister.service.IMeterWorkSceneRegisterService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * MeterWorkSceneRegister RESTful接口：
 *
 * @author generator
 * @version 1.0-SNAPSHORT 2020-10-19 11:26
 * 类描述
 * 修订历史：
 * 日期：2020-10-19
 * 作者：generator
 * 参考：
 * 描述：MeterWorkSceneRegister RESTful接口
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 * @see null
 */
@RestController
@RequestMapping("/${api.version}/meterworksceneregisters")
public class MeterWorkSceneRegisterController extends BaseRESTfulController {

    @Autowired
    IMeterWorkSceneRegisterService meterWorkSceneRegisterService;

    @ApiOperation(value = "获取列表", notes = "分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworksceneregister:view")
    @GetMapping(value = "/page")
    public RESTfulResult list(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterWorkSceneRegister> list = meterWorkSceneRegisterService.queryForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取列表", notes = "分页查询")
    @GetMapping(value = "/")
    public RESTfulResult listall(@RequestParam HashMap parmas) {
        try {
            List<MeterWorkSceneRegister> list = meterWorkSceneRegisterService.queryAll(parmas);
            return success(list);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取列表", notes = "分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworksceneregister:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterWorkSceneRegister> list = meterWorkSceneRegisterService.queryLikeForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "创建", notes = "根据MeterWorkSceneRegister对象创建")
    @ApiImplicitParam(name = "meterWorkSceneRegister", value = "详细实体meterWorkSceneRegister", required = true, dataType = "MeterWorkSceneRegister")
    //@RequiresPermissions("meterworksceneregister:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute MeterWorkSceneRegister model) {
        try {
            MeterWorkSceneRegister meterWorkSceneRegister = meterWorkSceneRegisterService.add(model);
            return success(meterWorkSceneRegister);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取详细信息", notes = "根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworksceneregister:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id) {
        try {
            MeterWorkSceneRegister meterWorkSceneRegister = meterWorkSceneRegisterService.getById(id);
            return success(meterWorkSceneRegister);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "更新详细信息", notes = "根据url的id来指定更新对象，并根据传过来的meterWorkSceneRegister信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
            @ApiImplicitParam(name = "meterWorkSceneRegister", value = "详细实体meterWorkSceneRegister", required = true, dataType = "MeterWorkSceneRegister")
    })
    //@RequiresPermissions("meterworksceneregister:update")
    @PutMapping(value = "/{id}", produces = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterWorkSceneRegister model) {
        try {
            model.setId(id);
            MeterWorkSceneRegister meterWorkSceneRegister = meterWorkSceneRegisterService.modify(model);
            return success(meterWorkSceneRegister);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "删除", notes = "根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworksceneregister:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id) {
        try {
            List<String> list = Arrays.asList(id.split(","));
            if (ListUtils.isNotEmpty(list)) {
                List<String> ids = ListUtils.convertList(list);
                meterWorkSceneRegisterService.delete(ids);
            }
            return success();
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "创建", notes = "根据MeterWorkSceneRegister对象创建")
    @ApiImplicitParam(name = "meterWorkSceneRegister", value = "详细实体meterWorkSceneRegister", required = true, dataType = "MeterWorkSceneRegister")
    //@RequiresPermissions("meterbaserailwayweight:create")
    @PostMapping(value = "/add")
    public RESTfulResult checkandadd(@RequestBody MeterWorkSceneRegister model) {
        RESTfulResult rm = failed();
        try {
            MeterWorkSceneRegister mbrw = meterWorkSceneRegisterService.checkandadd(model);
            if (mbrw != null) {
                return success(mbrw);
            } else {
                return failed("操作失败");
            }
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value = "修改", notes = "根据MeterWorkSceneRegister对象修改")
    @PostMapping(value = "/update")
    public RESTfulResult checkandupdate(@RequestBody MeterWorkSceneRegister model) {
        RESTfulResult rm = failed();
        try {
            int num = meterWorkSceneRegisterService.checkandupdate(model);
            if (num >= 1) {
                return success(num);
            } else {
                return failed("操作失败");
            }
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value = "删除/停用", notes = "根据MeterWorkSceneRegister对象停用")
    @PostMapping(value = "/abolish")
    public RESTfulResult abolish(@RequestBody List<MeterWorkSceneRegister> models) {
        RESTfulResult rm = failed();
        try {
            int num = meterWorkSceneRegisterService.abolish(models);
            if (num >= 1) {
                return success(num);
            } else {
                return failed("操作失败");
            }
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value = "启用", notes = "根据MeterWorkSceneRegister对象启用")
    @PostMapping(value = "/recover")
    public RESTfulResult recover(@RequestBody List<MeterWorkSceneRegister> models) {
        RESTfulResult rm = failed();
        try {
            int num = meterWorkSceneRegisterService.recover(models);
            if (num >= 1) {
                return success(num);
            } else {
                return failed("操作失败");
            }
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }
}
